1. 说明
    * 适用范围：本指南适用于SpringBoot+Vue等前后端分离项目。
    * 适配内容：
        * 东方通中间件(7.0.4.1)。
        * 达梦数据库(8)。
* * *
2. 数据库迁移
* 说明：MySQL数据库迁移到DM数据库。
* 步骤：
    1. 打开DM数据迁移工具；
    2. 新建工程-输入工程名-确认；
    3. 迁移-新建迁移-输入迁移名称-确认；
    4. 选择迁移方式-下一步；
    5. 输入MySQL数据库信息-下一步；
    6. 输入DM数据库信息-下一步；
    7. 指定对象复制或查询-下一步；
    8. 选择迁移对象-下一步；
    9. 审阅迁移任务-完成；
    10. 查看迁移错误日志，根据错误日志，进行相关处理。
* * *
3. 后端更换达梦数据源
* 说明：将MySQL数据源更换为DM数据源。
* 步骤：
    1. 将DM8的jar包，添加到mavne的本地仓库；
        ```
        mvn install:install-file -DgroupId=com.dm -DartifactId=DmJdbcDriver -Dversion=1.8.0 -Dpackaging=jar -Dfile=E:\DmJdbcDriver18.jar
        ``` 
    
    2. 修改项目中ruoyi-admin模块下的pom.xml文件；
        ```
        替换
        <dependency>
            <groupId>mysql</groupId>
            <artifactId>mysql-connector-java</artifactId>
        </dependency>
        为
        <dependency>
            <groupId>com.dm</groupId>
            <artifactId>DmJdbcDriver</artifactId>
            <version>1.8.0</version>
        </dependency>
        ```
    3. 修改项目中ruoyi-admin模块下的application-druid.yml文件；
        ```
        替换
        driverClassName: com.mysql.cj.jdbc.Driver
        druid:
            master:
            url: jdbc:mysql://127.0.0.1:3306/data_standard_dev?useUnicode=true&characterEncoding=utf8&zeroDateTimeBehavior=convertToNull&useSSL=true&serverTimezone=GMT%2B8
            username: test
            password: test
        为
        driverClassName: dm.jdbc.driver.DmDriver
        druid:
            master:
            url: jdbc:dm://127.0.0.1:5236/PS_SERVER?zeroDateTimeBehavior=convertToNull&useUnicode=true&characterEncoding=utf-8
            username: test
            password: test
        ```
    4. 确保网络通畅，启动服务，观察日志。
* * *
4. 后端项目打包为war包
* 说明：因需要部署到TongWeb7上，将以前的jar包，打包为war包。
* 步骤：
    1. 修改项目中ruoyi-admin模块下的pom.xml文件；
        ```
        替换
        <packaging>jar</packaging>
        为
        <packaging>war</packaging>
        ```
    2. 修改项目中ruoyi-framework模块下的pom.xml文件；
        ```
        替换
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-web</artifactId>
        </dependency>
        为
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-web</artifactId>
            <!--排除web启动中自动依赖的tomcat插件-->
            <exclusions>
                <exclusion>
                    <groupId>org.springframework.boot</groupId>
                    <artifactId>spring-boot-starter-tomcat</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
     3. 运行maven命令，进行打包操作。  
* * * 
5. linux安装TongWeb7
* 说明：在linux上安装TongWeb7.0.4.1。
* 步骤：
    1. 新建用户：tong7  密码：tongweb7；
    2. 安装命令：`sh Install_TW7.0.4.1_Enterprise_Liunx.bin -i console` 
* * *  
6. 后端部署到东方通中间件
* 说明：将后端项目打包后的war包，部署到TongWeb7中。
* 步骤：
    1. 登录TongWeb7控制台；
    2. 应用管理-部署应用-文件位置：服务器：war位置-开始部署；
    3. 应用名称：ps-server-应用前缀：ps-server-其他默认-下一步；
    4. 虚拟主机设置默认server-完成；
    5. 部署成功，通过http://127.0.0.1:8089/ps-server/可以访问到测试接口。
* * *
7. 前端部署到东方通中间件
* 说明：将前端项目打包好的dist包，部署到TongWeb7中。
* 步骤：
    1. 修改前端项目中的.env.production文件中的VUE_APP_BASE_API为你的后端项目名，例如VUE_APP_BASE_API = '/ps-server'。 
    2. 将前端项目打包后的dist改名ROOT，并在ROOT中创建WEB-INF目录，WEB-INF目录新建web.xml文件如下：
    ```
    <?xml version="1.0" encoding="UTF-8"?>
    <web-app xmlns="http://xmlns.jcp.org/xml/ns/javaee" 
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:schemaLocation="http://xmlns.jcp.org/xml/ns/javaee
        http://xmlns.jcp.org/xml/ns/javaee/web-app_3_1.xsd"
        version="3.1" metadata-complete="true">
        <display-name>Router for Tomcat</display-name>
        <error-page>
            <error-code>404</error-code>
            <location>/index.html</location>
        </error-page>
    </web-app>
    ```
    3. tongWeb部署ROOT(参考步骤6)，应用前缀/，虚拟主机设置默认server。
    4. 部署成功，通过http://127.0.0.1:8089可以访问到登录页面。
* * *
8. 问题记录
* 服务部署到东方通中间件，导出Excel乱码问题
    * 处理方式：登录TongWeb控制台-WEB容器配置-HTTP通道管理-tong-http-listener-其他设置-URL编码格式-UTF-8

